package m3r3;

import javax.sound.sampled.Clip;

public class Quiz {
	// Currently set Frequency
	double curVal = 87.5;

	// Tolerance, when the backgound noises of the quiz should fade
	double toleranz = 1;

	// Sound for the radio noise
	Sound noise = new Sound("sounds/whitenoise.wav", Clip.LOOP_CONTINUOUSLY, 1);

	public Quiz(Riddle[] riddle) {
		for (int i = 0; i < riddle.length; i++) {
			riddle[i].setCurDiff(1);
		}

	}

	public int searchRiddle(Riddle[] riddle) {

		while (true) {
			curVal = Radio.getFrequency();
			checkAllFinisched(riddle);

			for (int i = 0; i < riddle.length; i++) {
				/* Is current riddle in the set frequency range ? */
				if ((curVal > (riddle[i].frequency - toleranz) && curVal < (riddle[i].frequency + toleranz))) {
					if (!riddle[i].isLoopStarted()) {
						riddle[i].startLoop();
					}
					/*
					 * Is the current ridle near the right frequency and not yet
					 * finished?
					 */
					if ((curVal >= riddle[i].frequency - toleranz / 10 && curVal <= riddle[i].frequency + toleranz / 10)
							&& !riddle[i].isFinished()) {
						riddle[i].setReached(true);
					}
					/*
					 * Set current different of set frequency and riddle
					 * frequency from 0 to 1. (Only when in range, relative not
					 * absolute)
					 */
					riddle[i].setCurDiff(Math.abs(riddle[i].frequency - curVal) / toleranz);

				} else {
					/* Set it to one when out of range */
					riddle[i].setCurDiff(1);
				}

				if (riddle[i].isLoopStarted()) {
					/* fadeout noise, fadeIn background sounds */
					riddle[i].getBgSound().setVolume(1 - riddle[i].curDiff);
					noise.setVolume(riddle[i].curDiff);
				}

				if (riddle[i].isReached()) {
					/**
					 * This if/else ist especially for our quizzes, because
					 * instead of a riddle is a hint for the other riddles in
					 * riddle[4] which shall loop and never stop
					 **/
					if (i != 4) {
						noise.setVolume(0);
						riddle[i].getBgSound().setVolume(0.5);
						helpers.delay_s(3);
						riddle[i].getBgSound().setVolume(0.2);
						riddle[i].setReached(false);
						riddle[i].setQuizFinished(riddle(i, riddle));
						riddle[i].getBgSound().setVolume(1);
					} else {
						noise.setVolume(0);
						riddle[i].getBgSound().setVolume(0.2);
						riddle[i].startQuiz(true);

					}

				}
			}

		}

	}

	public boolean riddle(int riddleNummer, Riddle[] riddle) {

		riddle[riddleNummer].startQuiz(false);

		switch (riddleNummer + 1) {
		case 1:
			return riddle1(riddle[0]);
		case 2:
			return riddle2(riddle[1]);
		case 3:
			return riddle3(riddle[2]);
		case 4:
			return riddle4(riddle[3]);
		default:
			return false;
		}

	}

	/*
	 * In the first riddle, the player hears a list and has to say, if the
	 * spoken stuff is in "the soup". (Hints for this one in the sixth "riddle".
	 * The input is with two buttons, one with green the other with background
	 */
	private boolean riddle1(Riddle riddle) {

		Radio.setLed1(false, true, false); // green
		Radio.setLed2(true, false, false); // red

		riddle.sound.waitToEnd();

		// Ingredient1
		Sound ochsenschwanz = new Sound("sounds/1/ochsenschwanz.wav", 0, 1);
		Byte button = Radio.waitForButtonAndRangeCheck(riddle.frequency);
		ochsenschwanz.stop();
		if (button != 1)
			return false;

		// Ingredient2
		Sound zwiebel = new Sound("sounds/1/zwiebeln.wav", 0, 1);
		button = Radio.waitForButtonAndRangeCheck(riddle.frequency);
		zwiebel.stop();
		if (button != 1)
			return false;

		// Ingredient3
		Sound knollenselerie = new Sound("sounds/1/knollenselerie.wav", 0, 1);
		button = Radio.waitForButtonAndRangeCheck(riddle.frequency);
		knollenselerie.stop();
		if (button != 1)
			return false;

		// Ingredient4
		Sound fett = new Sound("sounds/1/fett.wav", 0, 1);
		button = Radio.waitForButtonAndRangeCheck(riddle.frequency);
		fett.stop();
		if (button != 2)
			return false;

		// Ingredient5
		Sound wasser = new Sound("sounds/1/wasser.wav", 0, 1);
		button = Radio.waitForButtonAndRangeCheck(riddle.frequency);
		wasser.stop();
		if (button != 1)
			return false;

		// Ingredient6
		Sound lorbeerblaetter = new Sound("sounds/1/lorbeerblaetter.wav", 0, 1);
		button = Radio.waitForButtonAndRangeCheck(riddle.frequency);
		lorbeerblaetter.stop();
		if (button != 1)
			return false;

		// Ingredient7
		Sound mehl = new Sound("sounds/1/mehl.wav", 0, 1);
		button = Radio.waitForButtonAndRangeCheck(riddle.frequency);
		mehl.stop();
		if (button != 2)
			return false;

		// Ingredient8
		Sound paprika = new Sound("sounds/1/paprika.wav", 0, 1);
		button = Radio.waitForButtonAndRangeCheck(riddle.frequency);
		paprika.stop();
		if (button != 2)
			return false;

		// Ingredient9
		Sound wein = new Sound("sounds/1/wein.wav", 0, 1);
		button = Radio.waitForButtonAndRangeCheck(riddle.frequency);
		wein.stop();
		if (button != 1)
			return false;

		// Ingredient10
		Sound tomatenmark = new Sound("sounds/1/tomatenmark.wav", 0, 1);
		button = Radio.waitForButtonAndRangeCheck(riddle.frequency);
		tomatenmark.stop();
		if (button != 2)
			return false;

		// Ingredient11
		Sound wacholderbeeren = new Sound("sounds/1/wacholderbeeren.wav", 0, 1);
		button = Radio.waitForButtonAndRangeCheck(riddle.frequency);
		wacholderbeeren.stop();
		if (button != 2)
			return false;

		// Ingredient12
		Sound rindfond = new Sound("sounds/1/rindfond.wav", 0, 1);
		button = Radio.waitForButtonAndRangeCheck(riddle.frequency);
		rindfond.stop();
		if (button != 2)
			return false;

		// Ingredient13
		Sound champignons = new Sound("sounds/1/champignons.wav", 0, 1);
		button = Radio.waitForButtonAndRangeCheck(riddle.frequency);
		champignons.stop();
		if (button != 2)
			return false;

		// Ingredient14
		Sound cayenne = new Sound("sounds/1/cayenne.wav", 0, 1);
		button = Radio.waitForButtonAndRangeCheck(riddle.frequency);
		cayenne.stop();
		if (button != 2)
			return false;

		// Ingredient15
		Sound sahne = new Sound("sounds/1/sahne.wav", 0, 1);
		button = Radio.waitForButtonAndRangeCheck(riddle.frequency);
		sahne.stop();
		if (button != 2)
			return false;

		return true;

	}

	/*
	 * In this riddle, the player has to enter a number in binary, where the
	 * three buttons represents each one digit of a the binary solution five
	 * (101 in binary)
	 */
	private boolean riddle2(Riddle riddle) {

		Radio.setLed1(false, true, false); // green = 1
		Radio.setLed2(true, false, false); // red = 2
		Radio.setLed3(false, false, true); // blue = 4

		boolean button1 = false, button2 = false, button3 = false;
		byte button;
		while (button1 == false || button2 == true || button3 == false) {
			button = Radio.waitForButtonAndRangeCheck(riddle.frequency);
			if (button == 1)
				button1 = helpers.xor(button1, true);
			if (button == 2)
				button2 = helpers.xor(button2, true);
			if (button == 3)
				button3 = helpers.xor(button3, true);
			if (button == 4)
				return false;
		}
		return true;
	}

	/*
	 * In this riddle, the player has to enter another number with a color code.
	 * The meanings of the colors should be visible on a cheat sheet somewhere
	 * in the room
	 */
	public boolean riddle3(Riddle riddle) {
		byte res = 0;

		Radio.setLed1(true, false, false); // red=32
		Radio.setLed2(false, true, false); // green=16
		Radio.setLed3(false, false, true); // blue 8

		byte button = Radio.waitForButtonAndRangeCheck(riddle.frequency);
		if (button == 1)
			res += 32;
		if (button == 2)
			res += 16;
		if (button == 3)
			res += 8;
		if (button == 4)
			return false;

		Radio.setLed2(true, true, false); // red+green = 1
		Radio.setLed1(true, false, true); // red+blue = 2
		Radio.setLed3(false, true, true); // green+blue = 4

		button = Radio.waitForButtonAndRangeCheck(riddle.frequency);
		if (button == 1)
			res += 1;
		if (button == 2)
			res += 2;
		if (button == 3)
			res += 4;
		if (button == 4)
			return false;

		return (res == 17);
	}

	/*
	 * In this riddle, the player has to enter a color code, also available
	 * anywhere in the escape room
	 */
	public boolean riddle4(Riddle riddle) {

		Radio.setLed1(true, false, false); // red
		Radio.setLed2(false, true, false); // green
		Radio.setLed3(false, false, true); // blue

		// Code solution is: R B R G B R R

		byte button = Radio.waitForButtonAndRangeCheck(riddle.frequency);
		if (button != 1)
			return false;

		button = Radio.waitForButtonAndRangeCheck(riddle.frequency);
		if (button != 3)
			return false;

		button = Radio.waitForButtonAndRangeCheck(riddle.frequency);
		if (button != 1)
			return false;

		button = Radio.waitForButtonAndRangeCheck(riddle.frequency);
		if (button != 2)
			return false;

		button = Radio.waitForButtonAndRangeCheck(riddle.frequency);
		if (button != 3)
			return false;

		button = Radio.waitForButtonAndRangeCheck(riddle.frequency);
		if (button != 1)
			return false;

		button = Radio.waitForButtonAndRangeCheck(riddle.frequency);
		if (button != 1)
			return false;

		return true;
	}



	/* When all riddles are finished, open the secret box */
	void checkAllFinisched(Riddle[] riddle) {

		boolean flag = true;
		for (int i = 0; i < riddle.length; i++) {
			if (!riddle[i].isFinished())
				flag = false;

		}
		if (flag) {
			Radio.openBox();
		}

	}

}
