package m3r3;

import javax.sound.sampled.Clip;

/*
 * One Riddle objet has the arguments
 * -name: For the name of the riddle
 * -frequency: the frequency on which the riddle should be heard
 * -quizAudio: the path of the audio file for the quiz
 * -loopAudio: the path of the audio file looping in the background on
 * 	the choosen frequency and near it 
 * 		
  */

public class Riddle {
	String name;
	double frequency;
	double curDiff;
	boolean reached;
	String quizAudio;
	String loopAudio;
	boolean loopStarted;
	boolean finished;
	Sound sound;
	Sound bgSound;
	boolean quizStarted;

	public Riddle(String name, double frequency, String quizAudio, String loopAudio) {
		this.name = name;
		this.frequency = frequency;
		this.reached = false;
		this.quizAudio = quizAudio;
		this.loopAudio = loopAudio;
		this.loopStarted = false;
		this.finished = false;
		this.sound = null;
		this.bgSound = null;
		this.quizStarted = false;
	}

	public boolean isFinished() {
		return finished;
	}

	public void setQuizFinished(boolean solved) {
		/* 
		 * If the riddle was solved, the green LEDs are blinking once.
		 * If not so the, the red LEDs are.
		*/
		if (solved) {
			System.out.println("The riddle \"" + this.name + "\" was solved!");
			Radio.setLed1(false, true, false);
			Radio.setLed2(false, true, false);
			Radio.setLed3(false, true, false);
		} else {
			System.out.println("The riddle \"" + this.name + "\" was NOT solved!");
			Radio.setLed1(true, false, true);
			Radio.setLed2(true, false, true);
			Radio.setLed3(true, false, true);
		}
		helpers.delay_ms(500);
		Radio.setLed1(false, false, false);
		Radio.setLed2(false, false, false);
		Radio.setLed3(false, false, false);
		this.sound.stop();
		this.quizStarted = false;
		this.finished = solved;

	}

	public double getCurDiff() {
		return curDiff;
	}

	public boolean isLoopStarted() {
		return loopStarted;
	}

	public void setLoopStarted(boolean loopStarted) {
		this.loopStarted = loopStarted;
	}

	public void setCurDiff(double curDiff) {
		this.curDiff = curDiff;
	}

	public boolean isReached() {
		return reached;
	}



	public void setReached(boolean reached) {
		this.reached = reached;
	}

	public Sound getSound() {
		return sound;
	}

	public void setSound(Sound sound) {
		this.sound = sound;
	}

	public double getFrequency() {
		return frequency;
	}

	public void setLoopAudio(String loopAudio) {
		this.loopAudio = loopAudio;
	}

	public void startLoop() {
		//Start loop at minimal volume
		bgSound = new Sound(loopAudio, Clip.LOOP_CONTINUOUSLY, 0);
		loopStarted = true;

	}

	public void startQuiz(boolean loop) {
		
		//Start the quiz at maximal volume. If loop is set, loop it, else play it once.
		if(!quizStarted){
		if (loop) {
			sound = new Sound(quizAudio, Clip.LOOP_CONTINUOUSLY, 1);

		}
		else
			sound = new Sound(quizAudio, 0, 1);
		
		quizStarted = true;
		}

	}


	public Sound getBgSound() {
	
		return bgSound;
	}

}
