package m3r3;

import java.io.File;
import java.io.IOException;

import javax.sound.sampled.*;
/* Class to deal with audio files.
 * This solution has a bad latency while changing the volume,
 * it'd be much better if you rewrite this.*/
public class Sound {

	Clip clip;
	FloatControl volume;
	double volumeDec;

	public Sound(String file, int loops, double d) {
		volumeDec = d;
		try {
			// Open an audio input stream.
			AudioInputStream audioIn = AudioSystem.getAudioInputStream(new File(file));
			// Get a sound clip resource.
			clip = AudioSystem.getClip();
			// Open audio clip and load samples from the audio input stream.
			clip.open(audioIn);
			clip.loop(loops);
			volume = (FloatControl) clip.getControl(FloatControl.Type.MASTER_GAIN);
			setVolume(volumeDec);
		} catch (UnsupportedAudioFileException e) {
			e.printStackTrace();
			System.out.println("\nNicht unterstützes Audioformat");

		} catch (IOException e) {
			e.printStackTrace();
		} catch (LineUnavailableException e) {
			e.printStackTrace();
		} catch (Exception e) {
			e.printStackTrace();
		}

	}

	public void stop() {
		clip.stop();
		clip.close();
	}


	public void setVolume(double value) {
		
		if (value < 0.01) value = 0.00;
		if (value > 1) value = 1.0;
		float dB = (float)(Math.log(value)/Math.log(10.0)*20.0);
		volume.setValue(dB);
		volumeDec=value;
	}

	public double getVolume() {
		return(volumeDec);
	}
	public void waitToEnd(){
		System.out.println("msLength: "+clip.getMicrosecondLength()/1000);
		helpers.delay_ms((int)(clip.getMicrosecondLength()/1000));
		this.stop();

	}

	public void increaseVolume(double value) {
			setVolume(value + getVolume());	
	}

	public void decreaseVolume(double value) {	
			setVolume((double)(getVolume() - value));	
	}
	 public void volumeControlInfo(){
		 System.out.println("min:"+volume.getMinimum()+"\nmax:"+volume.getMaximum()+"\n"+volume.getPrecision());
	 }
	 
	

}
