package m3r3.driver;

import java.io.File;
import m3r3.driver.fader.Fader;

public class ADC{
	static {
		File lib = new File("lib/" + System.mapLibraryName("adc"));
		System.load(lib.getAbsolutePath());
	}
	
	private static ADC instance;
	private Fader fader;
	
	private ADC(){
		init();
		fader = new Fader();
		update();
	}
	
	private static native void init();

	private static native int read ();
	
	public static ADC getInstance(){
		if(ADC.instance == null){
			ADC.instance = new ADC();
		}
		return ADC.instance;
	}
	
	public Fader getFader(){
		return fader;
	}
	
	void update(){
		fader.setValue(read());
	}
}