package m3r3.driver.fader;

public class Fader{
	
	private int value;
	private static final int[][] spectrumMap = {
	//	{min, max, Smin, Smax},
		{0, 1023, 0, 100},
		{0, 1023, 0, 1023},
		{0, 1023, 88, 108},
		{0, 1023, 150, 280}
	};
	
	public Fader(){
		this.value = 0;
	}
	
	public void setValue(int absValue){
		this.value = absValue;
	}
	
	private static double map(int min, int max, int smin, int smax, int value){
		return (double)(value - min) / (double)(max - min) * (double)(smax - smin) + (double)smin;
	}
	
	public double getFrequence(Spectrum spectrum){
		switch(spectrum){
			case PERCENT:
				return map(spectrumMap[0][0], spectrumMap[0][1], spectrumMap[0][2], spectrumMap[0][3], value);
			case TOTAL:
				return map(spectrumMap[1][0], spectrumMap[1][1], spectrumMap[1][2], spectrumMap[1][3], value);
			case FM:
				return map(spectrumMap[2][0], spectrumMap[2][1], spectrumMap[2][2], spectrumMap[2][3], value);
			case LW:
				return map(spectrumMap[3][0], spectrumMap[3][1], spectrumMap[3][2], spectrumMap[3][3], value);
			default: return 0;
		}
	}
	
	
}